using System.Data.SqlClient;

using StructureMapDemo.Entity;
using StructureMapDemo.Entity;

namespace StructureMapDemo.Services
{
    public interface IUserRepository {
        User FetchUserInformation( string userName, User validUserInformation );
        ChallengeResponse GetChallangeResponseInformation( User validUserInformation );
    }

    public class UserRepository : IUserRepository
    {
        public User FetchUserInformation( string userName, User validUserInformation )
        {
            var sqlConnection = new SqlConnection( Constants.ConnectionString );
            sqlConnection.Open();

            // 1....
            var query = string.Format( "Select UserID, UserName, Password from EmailUsers where UserName = '{0}'", userName );
            var userFetchCommand = new SqlCommand( query, sqlConnection );

            var reader = userFetchCommand.ExecuteReader();

            if ( !reader.HasRows ) { return validUserInformation; }

            if ( reader.Read() )
            {
                var fetchedUserName = reader.GetString( reader.GetOrdinal( "UserName" ) );
                var fetchedPassword = reader.GetString( reader.GetOrdinal( "Password" ) );
                var fetchedUserID = reader.GetInt32( reader.GetOrdinal( "UserID" ) );
                validUserInformation = new User( fetchedUserID, fetchedUserName, fetchedPassword );
                reader.Close();
            }
            return validUserInformation;
        }

        public ChallengeResponse GetChallangeResponseInformation( User validUserInformation )
        {
            string query;
            var sqlConnection = new SqlConnection( Constants.ConnectionString );
            query = string.Format( "Select ChallangeAnswer, AltChallangeAnswer from PasswordChallange where UserID = {0}", validUserInformation.UserID );
            var challangeCommand = new SqlCommand( query, sqlConnection );

            var reader = challangeCommand.ExecuteReader();

            var challangeResponse = reader.GetString( reader.GetOrdinal( "ChallangeAnswer" ) );
            var altChallangeResponse = reader.GetString( reader.GetOrdinal( "AltChallangeAnswer" ) );
            return new ChallengeResponse { Response = challangeResponse, AltResponse = altChallangeResponse };

        }
    }
}